<?php
namespace Controller;

use Doctrine\ORM\EntityManager;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;

use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DependencyInjection\InstanceManager;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\Events\PreDispatch\Listener;
use Zeedhi\Framework\HTTP\Kernel;
use Zeedhi\Framework\DataSource\FilterCriteria;

class Autenticator extends Listener{
    protected $dataSourceName = "operador";
    protected $dataSourceNameToSave;
    protected $entityManager;
    protected $service;
    protected $crudService;
    protected $environment;
    protected $connectionCustom;

    /**
     * Construtor do Controller.
     *
     * @param CrudService $crudService
     * @param EntityManager $entityManager
     * @param UnidadeService $service
     */
    public function __construct($crudService, EntityManager $entityManager, $environment, Kernel $kernel, $connectionCustom, $factory) {
        //var_dump('NO construtor');die;
        $this->entityManager = $entityManager;
        $this->crudService   = $crudService;
        $this->environment   = $environment;
        $this->kernel = $kernel;
        $this->connectionCustom = $connectionCustom;
        $this->factory =  $factory;
    }

    /*
     * Método que intercepta toda requisição feita ao backend.
     */
    public function preDispatch(Request $request) {
        $this->dataSourceName = 'operador';
        $headers = $this->kernel->getHttpRequest()->getHeaders();
        $emailOper = $headers->get("Emailoper");
        $senhaOper = $headers->get("Senhaoper");
        $conditions =  array();
        $filterCriteria = new FilterCriteria('operador', $conditions);
        $filterCriteria->addCondition('DSEMAILOPER', $emailOper);
        #$filterCriteria->addCondition('NRORG', '3278');
        $filterCriteria->addCondition('CDSENHAOPERWEB', $senhaOper);
        $response = new Response();
        $this->crudService->find($response, $filterCriteria);
        if(!$response->getDataSets()[0]->getRows())
            throw new \Exception('Usuario/senha incorretos');
        
        $operador = $response->getDataSets()[0]->getRows()[0];
        
        $this->environment->setCdFilial($operador['CDFILIALSELECIONADA']);
        $this->environment->setNrOrgTrab($operador['NRORG']);
        $this->environment->setNrOrg($operador['NRORG']);
        $this->environment->setCdOperador($operador['CDOPERADOR']);
        
        $paramsConn = $this->entityManager->getConnection()->getParams();
        if(isset($paramsConn['useVpd']) && $paramsConn['useVpd'] == 'true')
            $newEntityManager = $this->connectionCustom->updateVpdConnection($operador['NRORG']);
        else
            $newEntityManager = $this->entityManager;
        
        //criar função php que lê xmls para ler o service.xml e fazer um loop setando o entiti manager em todos que o usam.s
        $this->factory->setEntityManager($newEntityManager? $newEntityManager : $this->entityManager);
        //$this->factory->setEntityManager($newEntityManager);

        
    }
}
