<?php
namespace Service;

use Zeedhi\Framework\DTO\Response\Message;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\ORM\DateTime;
use Teknisa\Libs\Util\NewCode;

use Zeedhi\Framework\DB\StoredProcedure\Param;
use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;

class ErpService extends \Zeedhi\Framework\Controller\Simple {

    protected $connection;
    protected $entityManager;
    protected $newCode;

    public function __construct(\Doctrine\ORM\EntityManager $entityManager, NewCode $newCode)  {
        $this->connection = $entityManager->getConnection();
        $this->newCode = $newCode;
        $this->entityManager = $entityManager;
    }
    
    public function setEntityManager($entityManager) {
        $this->entityManager = $entityManager;
    }
    
    const INSERT_PRODUTO = "INSERT INTO USR_PRODUTO ( CDPRODINT, DSNIVEL1, DSNIVEL2, DSNIVEL3, DSNIVEL4, DSNIVEL5, DSNIVEL6, DSNIVEL7, DSNIVEL8, DSNIVEL9, DSNIVEL10, DSNIVEL11, DSNIVEL12, DSNIVEL13, DSNIVEL14, DSNIVEL15, DSNIVEL16, DSNIVEL17, DSNIVEL18, DSNIVEL19, DSNIVEL20, NMPRODUTO, DSCOMPLNOME, SGUNIDADE, VRFATCORR, VRFATOCONV, IDPRODESTO, CDPRODESTO, IDPRODATIVO, IDACAO, DTGRAVACAO, HRGRAVACAO ) VALUES ( :P_CDPRODINT, :P_DSNIVEL1, :P_DSNIVEL2, :P_DSNIVEL3, :P_DSNIVEL4, :P_DSNIVEL5, :P_DSNIVEL6, :P_DSNIVEL7, :P_DSNIVEL8, :P_DSNIVEL9, :P_DSNIVEL10, :P_DSNIVEL11, :P_DSNIVEL12, :P_DSNIVEL13, :P_DSNIVEL14, :P_DSNIVEL15, :P_DSNIVEL16, :P_DSNIVEL17, :P_DSNIVEL18, :P_DSNIVEL19, :P_DSNIVEL20, :P_NMPRODUTO, :P_DSCOMPLNOME, :P_SGUNIDADE, :P_VRFATCORR, :P_VRFATOCONV, :P_IDPRODESTO, :P_CDPRODESTO, :P_IDPRODATIVO, 'INCLUSAO', :P_DTGRAVACAO, :P_HRGRAVACAO )";
    const INSERT_FORNECEDOR = "INSERT INTO USR_CISPROT_FORNECEDOR ( CGCFORNE, CDFORPROTHEUS, NMRAZAOSOC, NMFANTFORNE, DSENDERECO, CDPAIS, NMPAIS, SGESTADO, CDMUNCIPIO, NMMUNICIPIO, CDCEP, NMBAIRRO, EMAIL, CDFORMPGTO, NMFORMPGTO, IDFORNATIV, IDACAO, DTGRAVACAO, HRGRAVACAO ) VALUES ( :P_CGCFORNE, :P_CDFORPROTHEUS, :P_NMRAZAOSOC, :P_NMFANTFORNE, :P_DSENDERECO, :P_CDPAIS, :P_NMPAIS, :P_SGESTADO, :P_CDMUNCIPIO, :P_NMMUNICIPIO, :P_CDCEP, :P_NMBAIRRO, :P_EMAIL, :P_CDFORMPGTO, :P_NMFORMPGTO, :P_IDFORNATIV, '1', :P_DTGRAVACAO, :P_HRGRAVACAO )";    
    const INSERT_CLIENTE = "INSERT INTO USR_CISPROT_CLIENTE ( CGCCLIE, CDCLIPROTHEUS, NMRAZAOSOC, NMFANTCLIE, DSENDERECO, CDPAIS, NMPAIS, SGESTADO, CDMUNCIPIO, NMMUNICIPIO, CDCEP, NMBAIRRO, EMAIL, CDFORMPGTO, NMFORMPGTO, IDCLIEATIV, IDACAO, DTGRAVACAO, HRGRAVACAO ) VALUES ( :P_CGCCLIE, :P_CDCLIPROTHEUS, :P_NMRAZAOSOC, :P_NMFANTCLIE, :P_DSENDERECO, :P_CDPAIS, :P_NMPAIS, :P_SGESTADO, :P_CDMUNCIPIO, :P_NMMUNICIPIO, :P_CDCEP, :P_NMBAIRRO, :P_EMAIL, :P_CDFORMPGTO, :P_NMFORMPGTO, :P_IDCLIEATIV, '1', :P_DTGRAVACAO, :P_HRGRAVACAO )";
    const INSERT_IMPORTANFENTRADA = "INSERT INTO USR_CISORDEM_COMPRA ( CDCENTCUST, NRAUTOFORNE, CDFORNECED, NRNOTAFISCAL, DTENTRADA, DTEMISSAO, CDPRODUTO, VRQUANTIDADE, VRQUANTAT, VRUNITARIO, CDSERIE, IDACAO, DTGRAVACAO, HRGRAVACAO ) VALUES ( :P_CDCENTCUST, :P_NRAUTOFORNE, :P_CDFORNECED, :P_NRNOTAFISCAL, :P_DTENTRADA, :P_DTEMISSAO, :P_CDPRODUTO, :P_VRQUANTIDADE, :P_VRQUANTAT, :P_VRUNITARIO, :P_CDSERIE, '1', :P_DTGRAVACAO, :P_HRGRAVACAO )";
    const INSERT_DEVOCOMPRA = "INSERT INTO USR_CISDEVO_COMPRA ( CDCENTCUST, NRAUTOFORNE, CDFORNECED, NRNOTAFISCAL, DTSAIDA, DTEMISSAO, CDPRODUTO, VRQUANTIDADE, VRQUANTAT, VRUNITARIO, CDSERIE, IDACAO, DTGRAVACAO, HRGRAVACAO ) VALUES ( :P_CDCENTCUST, :P_NRAUTOFORNE, :P_CDFORNECED, :P_NRNOTAFISCAL, :P_DTSAIDA, :P_DTEMISSAO, :P_CDPRODUTO, :P_VRQUANTIDADE, :P_VRQUANTAT, :P_VRUNITARIO, :P_CDSERIE, '1', :P_DTGRAVACAO, :P_HRGRAVACAO )";
    const INSERT_ATUPEDVENDA = "INSERT INTO USR_CISNF_TRANS ( NRPEDVENDA, IDSTATUSNFE, NRACESSONFE, DTEMISSAO, NRNOTAFISCAL, CDSERIE, IDACAO, DTGRAVACAO, HRGRAVACAO ) VALUES ( :P_NRPEDVENDA, :P_IDSTATUSNFE, :P_NRACESSONFE, :P_DTEMISSAO, :P_NRNOTAFISCAL, :P_CDSERIE, '1', :P_DTGRAVACAO, :P_HRGRAVACAO )";
    const INSERT_BAIXAUTF = "INSERT INTO USR_CISBAIXA_AUTOFORNE ( CDCENTCUST, NRAUTOFORNE, CDITEM, CDPRODUTO, IDACAO, DTGRAVACAO, HRGRAVACAO ) VALUES ( :P_CDCENTCUST, :P_NRAUTOFORNE, :P_CDITEM, :P_CDPRODUTO, '1', :P_DTGRAVACAO, :P_HRGRAVACAO )";
    
    const GET_PRODUTO = "SELECT COUNT(CDPRODINT) AS RESUL FROM USR_PRODUTO WHERE CDPRODINT = :P_CDPRODINT";
    const GET_FORNECEDOR = "SELECT COUNT(CGCFORNE) AS RESUL FROM USR_CISPROT_FORNECEDOR WHERE CGCFORNE = :P_CGCFORNE";
    const GET_CLIENTE = "SELECT COUNT(CGCCLIE) AS RESUL FROM USR_CISPROT_CLIENTE WHERE CGCCLIE = :P_CGCCLIE";
    const GET_NFENTRADA = "SELECT COUNT(NRNOTAFISCAL) AS RESUL FROM USR_CISORDEM_COMPRA WHERE NRNOTAFISCAL = :P_NRNOTAFISCAL AND CDPRODUTO = :P_CDPRODUTO";
    const GET_DEVOCOMPRA = "SELECT COUNT(NRNOTAFISCAL) AS RESUL FROM USR_CISDEVO_COMPRA WHERE NRNOTAFISCAL = :P_NRNOTAFISCAL AND CDPRODUTO = :P_CDPRODUTO";
    const GET_ATUPEDVENDA = "SELECT COUNT(NRPEDVENDA) AS RESUL FROM USR_CISNF_TRANS WHERE NRPEDVENDA = :P_NRPEDVENDA";
    const GET_BAIXAAUTF = "SELECT COUNT(*) AS RESUL FROM USR_CISBAIXA_AUTOFORNE WHERE CDCENTCUST = :P_CDCENTCUST AND NRAUTOFORNE = :P_NRAUTOFORNE AND CDITEM = :P_CDITEM AND CDPRODUTO = :P_CDPRODUTO";
    const GET_SOLICOMPRA = "SELECT * FROM USR_ITEMSOLI_SHA WHERE NRITEMSOLI BETWEEN :P_NRITEMSOLIINI AND :P_NRITEMSOLIFIM";
    const GET_MAXSOLI = "SELECT MAX(NRITEMSOLI) AS MAXSOLI FROM USR_ITEMSOLI_SHA";
    const GET_MINSOLI = "SELECT MIN(NRITEMSOLI) AS MINSOLI FROM USR_ITEMSOLI_SHA WHERE DTEXPORTADO IS NULL";
    
    const UPDATE_PRODUTO = "UPDATE USR_PRODUTO SET CDPRODINT = :P_CDPRODINT, CDTIPO = :P_CDTIPO, DESCTIPO = :P_DESCTIPO, CDGRUPO = :P_CDGRUPO, DESCGRUPO = :P_DESCGRUPO, CDSUBGRUPO = :P_CDSUBGRUPO, DESCSUBGRUPO = :P_DESCSUBGRUPO, CDPASTA = :P_CDPASTA, DESCPASTA = :P_DESCPASTA, NMPRODUTO = :P_NMPRODUTO, SGUNIDADE = :P_SGUNIDADE, VRFATCORR = :P_VRFATCORR, VRFATOCONV = :P_VRFATOCONV, IDPRODESTO = :P_IDPRODESTO, CDPRODESTO = :P_CDPRODESTO, IDPRODATIVO = :P_IDPRODATIVO, IDACAO = :P_IDACAO, DTGRAVACAO = :P_DTGRAVACAO, HRGRAVACAO = :P_HRGRAVACAO, LOG_ERRO = NULL, DTIMPORTACAO = NULL, HRIMPORTACAO = NULL WHERE CDPRODINT = :P_CDPRODINT";
    const UPDATE_FORNECEDOR = "UPDATE USR_CISPROT_FORNECEDOR SET CGCFORNE = :P_CGCFORNE, CDFORPROTHEUS = :P_CDFORPROTHEUS, NMRAZAOSOC = :P_NMRAZAOSOC , NMFANTFORNE = :P_NMFANTFORNE, DSENDERECO = :P_DSENDERECO , CDPAIS = :P_CDPAIS, NMPAIS = :P_NMPAIS, SGESTADO = :P_SGESTADO, CDMUNCIPIO = :P_CDMUNCIPIO, NMMUNICIPIO = :P_NMMUNICIPIO, CDCEP = :P_CDCEP, NMBAIRRO = :P_NMBAIRRO, EMAIL = :P_EMAIL, CDFORMPGTO = :P_CDFORMPGTO, NMFORMPGTO = :P_NMFORMPGTO, IDFORNATIV = :P_IDFORNATIV, IDACAO = :P_IDACAO, DTGRAVACAO = :P_DTGRAVACAO, HRGRAVACAO = :P_HRGRAVACAO, LOG_ERRO = NULL, DTIMPORTACAO = NULL, HRIMPORTACAO = NULL WHERE CGCFORNE = :P_CGCFORNE";
    const UPDATE_CLIENTE = "UPDATE USR_CISPROT_CLIENTE SET CGCCLIE = :P_CGCCLIE, CDCLIPROTHEUS = :P_CDCLIPROTHEUS, NMRAZAOSOC = :P_NMRAZAOSOC, NMFANTCLIE = :P_NMFANTCLIE, DSENDERECO = :P_DSENDERECO, CDPAIS = :P_CDPAIS, NMPAIS = :P_NMPAIS, SGESTADO = :P_SGESTADO, CDMUNCIPIO = :P_CDMUNCIPIO, NMMUNICIPIO = :P_NMMUNICIPIO, CDCEP = :P_CDCEP, NMBAIRRO = :P_NMBAIRRO, EMAIL = :P_EMAIL, CDFORMPGTO = :P_CDFORMPGTO, NMFORMPGTO = :P_NMFORMPGTO, IDCLIEATIV = :P_IDCLIEATIV, IDACAO = :P_IDACAO, DTGRAVACAO = :P_DTGRAVACAO, HRGRAVACAO = :P_HRGRAVACAO, LOG_ERRO = NULL, DTIMPORTACAO = NULL, HRIMPORTACAO = NULL WHERE CGCCLIE = :P_CGCCLIE";
    const UPDATE_IMPORTANFE = "UPDATE USR_CISORDEM_COMPRA SET NRAUTOFORNE = :P_NRAUTOFORNE, CDFORNECED = :P_CDFORNECED, DTENTRADA = :P_DTENTRADA, DTEMISSAO = :P_DTEMISSAO, CDPRODUTO = :P_CDPRODUTO, VRQUANTIDADE = :P_VRQUANTIDADE, VRQUANTAT = :P_VRQUANTAT, VRUNITARIO = :P_VRUNITARIO, CDSERIE = :P_CDSERIE, IDACAO = :P_IDACAO, DTGRAVACAO = :P_DTGRAVACAO, HRGRAVACAO = :P_HRGRAVACAO, LOG_ERRO = NULL, DTIMPORTACAO = NULL, HRIMPORTACAO = NULL WHERE NRNOTAFISCAL = :P_NRNOTAFISCAL AND CDPRODUTO = :P_CDPRODUTO";
    const UPDATE_DEVOCOMPRA = "UPDATE USR_CISDEVO_COMPRA SET NRAUTOFORNE = :P_NRAUTOFORNE, CDFORNECED = :P_CDFORNECED, DTSAIDA = :P_DTSAIDA, DTEMISSAO = :P_DTEMISSAO, CDPRODUTO = :P_CDPRODUTO, VRQUANTIDADE = :P_VRQUANTIDADE, VRQUANTAT = :P_VRQUANTAT, VRUNITARIO = :P_VRUNITARIO, CDSERIE = :P_CDSERIE, IDACAO = :P_IDACAO, DTGRAVACAO = :P_DTGRAVACAO, HRGRAVACAO = :P_HRGRAVACAO, LOG_ERRO = NULL, DTIMPORTACAO = NULL, HRIMPORTACAO = NULL WHERE NRNOTAFISCAL = :P_NRNOTAFISCAL AND CDPRODUTO = :P_CDPRODUTO";
    const UPDATE_ATUPEDVENDA = "UPDATE USR_CISNF_TRANS SET IDSTATUSNFE = :P_IDSTATUSNFE, NRACESSONFE = :P_NRACESSONFE, DTEMISSAO = :P_DTEMISSAO, NRNOTAFISCAL = :P_NRNOTAFISCAL, CDSERIE = :P_CDSERIE, IDACAO = :P_IDACAO, DTGRAVACAO = :P_DTGRAVACAO, HRGRAVACAO = :P_HRGRAVACAO, LOG_ERRO = NULL, DTIMPORTACAO = NULL, HRIMPORTACAO = NULL WHERE NRPEDVENDA = :P_NRPEDVENDA";
    const UPDATE_BAIXAUTF = "UPDATE USR_CISBAIXA_AUTOFORNE SET IDACAO = :P_IDACAO, DTGRAVACAO = :P_DTGRAVACAO, HRGRAVACAO = :P_HRGRAVACAO, LOG_ERRO = NULL, DTIMPORTACAO = NULL, HRIMPORTACAO = NULL WHERE CDCENTCUST = :P_CDCENTCUST AND NRAUTOFORNE = :P_NRAUTOFORNE AND CDITEM = :P_CDITEM AND CDPRODUTO = :P_CDPRODUTO";
    const UPDATE_SOLICOMPRA = "UPDATE USR_ITEMSOLI_SHA SET DTEXPORTADO = SYSDATE WHERE NRITEMSOLI BETWEEN :P_NRITEMSOLIINI AND :P_NRITEMSOLIFIM";
    
    const PROCEDURE_IMPORTA_PRODUTO = 'USR_IMPORTA_PRODUTO_DECIO';
    const PROCEDURE_IMPORTA_FORNECEDOR = 'USR_PROT_IMPORTA_FORNECEDOR';
    const PROCEDURE_IMPORTA_CLIENTE = 'USR_PROT_IMPORTA_CLIENTE';
    const PROCEDURE_IMPORTA_NFENTRADA = 'USR_PROT_IMPORTA_NFENTRADA';
    const PROCEDURE_IMPORTA_DEVOCOMPRA = 'USR_PROT_IMPORTA_DEVOCOMPRA';
    const PROCEDURE_ATUALIZA_PEDIDOVENDA = 'USR_PROT_ATUALIZA_PEDIDOVENDA';
    const PROCEDURE_BAIXA_AUTOFORNE = 'USR_PROT_BAIXA_AUTOFORNE';
    
    const GET_MAX_SEQLOG = "SELECT NVL(MAX(SEQLOG),0) AS MAX_SEQLOG FROM USR_LOG_WEBSERVICE";
    public function getMaxSeqLog() {
        try {
            $params = array();
            return $this->entityManager->getConnection()->fetchAll(self::GET_MAX_SEQLOG, $params);
        } catch (\Exception $e) {
            throw $e;
        }
    }
    
    //constantes com campos que serão gravados na tabela de log
    const CADASTRO_PRODUTO_LOG_FIELDS = array('SEQLOG', 'DSMETODO', 'IDACAO', 'IDTIPINTEGR', 'XMLLOG', 'OBSLOG', 'DSLOGINT', 'DTINCLUSAO', 'CDPRODUTO' );
    const CADASTRO_PRODUTO_DRILL_LOG_FIELDS = array('SEQLOG', 'DSMETODO', 'IDACAO', 'OBSLOG', 'DSLOGINT', 'DTINCLUSAO', 'CDPRODUTO');
    const CADASTRO_FORNECEDOR_LOG_FIELDS = array('SEQLOG', 'DSMETODO', 'IDACAO', 'IDTIPINTEGR', 'XMLLOG', 'OBSLOG', 'DSLOGINT', 'DTINCLUSAO', 'CDFORNECED' );
    const CADASTRO_CLIENTE_LOG_FIELDS = array('SEQLOG', 'DSMETODO', 'IDACAO', 'IDTIPINTEGR', 'XMLLOG', 'OBSLOG', 'DSLOGINT', 'DTINCLUSAO', 'CDCLIENTE' );
    const IMPORTA_NFENTRADA_LOG_FIELDS = array('SEQLOG', 'DSMETODO', 'IDACAO', 'IDTIPINTEGR', 'XMLLOG', 'OBSLOG', 'DSLOGINT', 'DTINCLUSAO', 'NRLANCTONF', 'CDFORNECED', 'NRAUTOFORN', 'CDFILMOVI' );
    
    const IMPORTA_NFENTRADA_DRILL_LOG_FIELDS = array('SEQLOG', 'DSMETODO', 'IDACAO', 'OBSLOG', 'DSLOGINT', 'DTINCLUSAO', 'CDPRODUTO', 'NRSEQITPROD', 'NRSEQUITEM');
    const EXPORTA_AF_LOG_FIELDS = array('SEQLOG', 'DSMETODO', 'IDACAO', 'IDTIPINTEGR', 'XMLLOG', 'OBSLOG', 'DSLOGINT', 'DTINCLUSAO', 'NRLANCTONF', 'CDFORNECED', 'NRAUTOFORN', 'CDFILMOVI' );
    const EXPORTA_AF_DRILL_LOG_FIELDS = array('SEQLOG', 'DSMETODO', 'IDACAO', 'OBSLOG', 'DSLOGINT', 'DTINCLUSAO', 'CDPRODUTO', 'CDFILIAL', 'NRLANCTONF', 'NRSEQITPROD', 'NRLANCESTQ', 'NRSEQUITEM', 'NRAUTOFORN', 'CDFILMOVI');
    const ATUALIZA_PEDIDOVENDA_LOG_FIELDS = array('SEQLOG', 'DSMETODO', 'IDACAO', 'IDTIPINTEGR', 'XMLLOG', 'OBSLOG', 'DSLOGINT', 'DTINCLUSAO');
    
    public function gravaLogWebservice($xml, $metodo, $arrXml, $messageLog){
     /*   switch($metodo){
            case 'CadastraProduto': 
                $query = $this->montaQuerryLog(self::CADASTRO_PRODUTO_LOG_FIELDS, 'USR_LOG_WEBSERVICE');
                $params = $this->montaParamsLog(self::CADASTRO_PRODUTO_LOG_FIELDS, $arrXml, $xml, $metodo, 'RECEBER', $messageLog);
                $params['P_DSLOGINT'] = 'Erro ao cadastrar o Produto: '.$arrXml['CDPRODINT'].' - '.$arrXml['NMPRODUTO'].' Ativo: '.$arrXml['IDPRODATIVO']; //'mensagem custom';
                break;
            case 'CadastraFornecedor':
                $query = $this->montaQuerryLog(self::CADASTRO_FORNECEDOR_LOG_FIELDS, 'USR_LOG_WEBSERVICE');
                $params = $this->montaParamsLog(self::CADASTRO_FORNECEDOR_LOG_FIELDS, $arrXml, $xml, $metodo, 'RECEBER', $messageLog);
                $params['P_DSLOGINT'] = 'Erro ao cadastrar o Fornecedor: '.$arrXml['CGCFORNE'].' - '.$arrXml['NMFANTFORNE'].' Ativo: '.$arrXml['IDFORNATIV']; //'mensagem custom';
                break;
            case 'CadastraCliente' :
                $query = $this->montaQuerryLog(self::CADASTRO_CLIENTE_LOG_FIELDS, 'USR_LOG_WEBSERVICE');
                $params = $this->montaParamsLog(self::CADASTRO_CLIENTE_LOG_FIELDS, $arrXml, $xml, $metodo, 'RECEBER', $messageLog);
                $params['P_DSLOGINT'] = 'Erro ao cadastrar o Cliente: '.$arrXml['CGCCLIE'].' - '.$arrXml['NMFANTCLIE'].' Ativo: '.$arrXml['IDCLIEATIV']; //'mensagem custom';
                break;
            case 'ImportaNFEntrada' :
                $query = $this->montaQuerryLog(self::IMPORTA_NFENTRADA_LOG_FIELDS, 'USR_LOG_WEBSERVICE');
                $params = $this->montaParamsLog(self::IMPORTA_NFENTRADA_LOG_FIELDS, $arrXml, $xml, $metodo, 'RECEBER', $messageLog);
                $params['P_DSLOGINT'] = 'Erro ao cadastrar a NF Entrada N°: '.$arrXml['NRNOTAFISCAL'].' Referente a AF : '.$arrXml['NRAUTOFORNE'].' Fornecedor :'.$arrXml['CDFORNECED']; //'mensagem custom';
                if($arrXml['PRODUTO'][0]){
                    foreach($arrXml['PRODUTO'] as $produto){
                        $queryDrill = $this->montaQuerryLog(self::IMPORTA_NFENTRADA_DRILL_LOG_FIELDS, 'USR_LOG_WEBSERVICE_DRILL');
                        $paramsDrill = $this->montaParamsLog(self::IMPORTA_NFENTRADA_DRILL_LOG_FIELDS, $produto, $xml, $metodo, 'RECEBER', $messageLog, $params);
                        try{
                            $this->entityManager->getConnection()->executeQuery($queryDrill, $paramsDrill);
                        }
                        catch (\Exception $e) {
                            return $e->getMessage();
                        }
                    }
                }
                else{
                    $queryDrill = $this->montaQuerryLog(self::IMPORTA_NFENTRADA_DRILL_LOG_FIELDS, 'USR_LOG_WEBSERVICE_DRILL');
                    $paramsDrill = $this->montaParamsLog(self::IMPORTA_NFENTRADA_DRILL_LOG_FIELDS, $arrXml['PRODUTO'], $xml, $metodo, 'RECEBER', $messageLog, $params);
                    try{
                        $this->entityManager->getConnection()->executeQuery($queryDrill, $paramsDrill);
                    }
                    catch (\Exception $e) {
                        return $e->getMessage();
                    }
                }
                break;
            case 'ExportaAF' :
                $query = $this->montaQuerryLog(self::EXPORTA_AF_LOG_FIELDS, 'USR_LOG_WEBSERVICE');
                $params = $this->montaParamsLog(self::EXPORTA_AF_LOG_FIELDS, $arrXml, $xml, $metodo, 'ENVIAR', $messageLog);
                $params['P_DSLOGINT'] = 'Erro ao exportar AF N°: '.$arrXml['NRAUTOFORNE'].' Fornecedor: '.$arrXml['CDFORNECED'].' Pagamento: '.$arrXml['CDCONDFORN'].' Codigo Exportação: '.$arrXml['CDCENTCUST']; //'mensagem custom';
                if($arrXml['_PCITENS']['TKPCITEM'][0]){
                    foreach($arrXml['_PCITENS']['TKPCITEM'] as $items){
                        $queryDrill = $this->montaQuerryLog(self::EXPORTA_AF_DRILL_LOG_FIELDS, 'USR_LOG_WEBSERVICE_DRILL');
                        $paramsDrill = $this->montaParamsLog(self::EXPORTA_AF_DRILL_LOG_FIELDS, $items, $xml, $metodo, 'ENVIAR', $messageLog, $params);
                        try{
                        $this->entityManager->getConnection()->executeQuery($queryDrill, $paramsDrill);
                        }
                        catch (\Exception $e) {
                            return $e->getMessage();
                        }
                    }
                }
                else{
                    $queryDrill = $this->montaQuerryLog(self::EXPORTA_AF_DRILL_LOG_FIELDS, 'USR_LOG_WEBSERVICE_DRILL');
                    $paramsDrill = $this->montaParamsLog(self::EXPORTA_AF_DRILL_LOG_FIELDS, $arrXml['_PCITENS']['TKPCITEM'], $xml, $metodo, 'ENVIAR', $messageLog, $params);
                    try{
                        $this->entityManager->getConnection()->executeQuery($queryDrill, $paramsDrill);
                    }
                    catch (\Exception $e) {
                        return $e->getMessage();
                    }
                }
                break;
            case 'AtualizaPedidoVenda':
                $query = $this->montaQuerryLog(self::ATUALIZA_PEDIDOVENDA_LOG_FIELDS, 'USR_LOG_WEBSERVICE');
                $params = $this->montaParamsLog(self::ATUALIZA_PEDIDOVENDA_LOG_FIELDS, $arrXml, $xml, $metodo, 'RECEBER', $messageLog);
                $params['P_DSLOGINT'] = 'Erro ao atualizar status da NotaFiscal numero: '.$arrXml['NRNOTAFISCAL'].' chave de acesso: '.$arrXml['NRACESSONFE']; //'mensagem custom';
                break;
            case 'DevolucaoDeCompra' :
                $query = $this->montaQuerryLog(self::IMPORTA_NFENTRADA_LOG_FIELDS, 'USR_LOG_WEBSERVICE');
                $params = $this->montaParamsLog(self::IMPORTA_NFENTRADA_LOG_FIELDS, $arrXml, $xml, $metodo, 'RECEBER', $messageLog);
                $params['P_DSLOGINT'] = 'Erro ao cadastrar a NF Devolucao N°: '.$arrXml['NRNOTAFISCAL'].' Referente a AF : '.$arrXml['NRAUTOFORNE'].' Fornecedor :'.$arrXml['CDFORNECED']; //'mensagem custom';
                if($arrXml['PRODUTO'][0]){
                    foreach($arrXml['PRODUTO'] as $produto){
                        $queryDrill = $this->montaQuerryLog(self::IMPORTA_NFENTRADA_DRILL_LOG_FIELDS, 'USR_LOG_WEBSERVICE_DRILL');
                        $paramsDrill = $this->montaParamsLog(self::IMPORTA_NFENTRADA_DRILL_LOG_FIELDS, $produto, $xml, $metodo, 'RECEBER', $messageLog, $params);
                        try{
                            $this->entityManager->getConnection()->executeQuery($queryDrill, $paramsDrill);
                        }
                        catch (\Exception $e) {
                            return $e->getMessage();
                        }
                    }
                }
                else{
                    $queryDrill = $this->montaQuerryLog(self::IMPORTA_NFENTRADA_DRILL_LOG_FIELDS, 'USR_LOG_WEBSERVICE_DRILL');
                    $paramsDrill = $this->montaParamsLog(self::IMPORTA_NFENTRADA_DRILL_LOG_FIELDS, $arrXml['PRODUTO'], $xml, $metodo, 'RECEBER', $messageLog, $params);
                    try{
                        $this->entityManager->getConnection()->executeQuery($queryDrill, $paramsDrill);
                    }
                    catch (\Exception $e) {
                        return $e->getMessage();
                    }
                }
                break;
        } //Fim do switch
        
        try{
            $this->entityManager->getConnection()->executeQuery($query, $params);
        }
        catch (\Exception $e) {
            return $e->getMessage();
        }
        */
    }
    
    public function montaParamsLog($arrayParams, $arrayValues, $xml = null, $metodo = null, $enviarReceber = null, $messageLog, $params){

        $params = $params? $params : array();
    
        
        $arrayValues['CDCLIENTE'] = $arrayValues['CDCLIENTE'] ? $arrayValues['CDCLIENTE'] : $arrayValues['CGCCLIE'];
        $arrayValues['CDFORNECED'] = $arrayValues['CDFORNECED'] ?  $arrayValues['CDFORNECED'] : $arrayValues['CGCFORNE'];
        $arrayValues['CDPRODUTO'] = $arrayValues['CDPRODUTO'] ? $arrayValues['CDPRODUTO'] : $arrayValues['CDPRODINTE'];
        $arrayValues['NRAUTOFORN'] = $arrayValues['NRAUTOFORN'] ? $arrayValues['NRAUTOFORN'] : $arrayValues['NRAUTOFORNE'];
        $enviarReceber ? $arrayValues['IDTIPINTEGR'] = $enviarReceber : null;
        $metodo ? $arrayValues['DSMETODO'] = $metodo : null;
        $xml? $arrayValues['XMLLOG'] = $xml : null;
        
        
        $seqLog = self::getMaxSeqLog();
        $seqMaxLog = $seqLog[0]['MAX_SEQLOG']+1;
        
        $arrayValues['SEQLOG'] = $seqMaxLog;
        
        if($arrayValues['IDACAO']){
            switch($arrayValues['IDACAO']){
                case 1:
                    $arrayValues['IDACAO'] =  'INCLUSAO';
                    break;
                case 2:
                    $arrayValues['IDACAO'] =  'ALTERACAO';
                    break;
                case 3:
                    $arrayValues['IDACAO'] =  'EXCLUSAO';
                    break;
            }
        }
        
            
        foreach($arrayParams as $key => $value) {
            $name = 'P_'.$value;
                
            $params[$name] = $params[$name]? $params[$name] : $arrayValues[$value];
            
        }
        
        $params['P_DTINCLUSAO'] = date('d/m/y');
        $params['P_OBSLOG'] = $messageLog;
        
        return $params;
    }
    
    private function montaQuerryLog($fields, $tabela){
		$query = '';
		$campos = '';
		$values = '';
		
		foreach ($fields as $key => $value) {
		        if($campos == ''){
		            $campos = $campos.$value;
		            $values = $values   .':P_'.$value;
		        }
		        else{
				    $campos = $campos.', '.$value;
		            $values = $values.', '.':P_'.$value;
		        }
		}
		
		$query = 'INSERT INTO '.$tabela.' ('.$campos.') VALUES ('.$values.')';
		
		return $query;
	}
    
    public function montaParamsSQL($arrayParams) {
        $params = array();
        $dsCount = 0;    
        foreach($arrayParams as $name => $value) {
            $name = 'P_'.$name;
            if($name == 'P_DSNIVEL') {
                foreach($value as $rowNum  => $rowVal){
                    $params[$name.strval($rowNum+1)] = $rowVal;
                }
            } else {
                if($value == '?')
                    $value = null;
                    
                $params[$name] = $value;
            }
            
        }
        
        $params['P_DTGRAVACAO'] = date('d/m/y');
        $params['P_HRGRAVACAO'] = date('H:i');

        return $params;
    }
    
    public function montaQryProduto($arrayParams){
        $stQryNivel = '';
        $stQryNivelParams = '';
        $stQryCampos = "INSERT INTO USR_PRODUTO ( CDPRODINT, NMPRODUTO, DSCOMPLNOME, SGUNIDADE, VRFATCORR, VRFATOCONV, IDPRODESTO, CDPRODESTOINT, IDPRODATIVO, IDACAO, DTGRAVACAO, HRGRAVACAO, CDBARPRODUTO";
        $stQryparams = ") VALUES ( :P_CDPRODINT, :P_NMPRODUTO, :P_DSCOMPLNOME, :P_SGUNIDADE, :P_VRFATCORR, :P_VRFATOCONV, :P_IDPRODESTO, :P_CDPRODESTOINT, :P_IDPRODATIVO, 'INCLUSAO', :P_DTGRAVACAO, :P_HRGRAVACAO, :P_CDBARPRODUTO";
        $stQryCompleta = '';
        foreach($arrayParams['DSNIVEL'] as $rowNum  => $rowVal) {
            $stQryNivel =  $stQryNivel.', DSNIVEL'.strval($rowNum+1);
            $stQryNivelParams = $stQryNivelParams.', :P_DSNIVEL'.strval($rowNum+1);
        }
        $stQryCompleta = $stQryCampos.$stQryNivel.$stQryparams.$stQryNivelParams.')';
        
        return $stQryCompleta;
    }
    
    public function montaQryUpdateProduto($arrayParams){
        $stQryNivel = '';
        $stQryNivelParams = '';
        $stQryCampos = "UPDATE USR_PRODUTO SET CDBARPRODUTO = :P_CDBARPRODUTO, CDPRODINT = :P_CDPRODINT, CDARVPRODINT = :P_CDARVPRODINT, NMPRODUTO = :P_NMPRODUTO, DSCOMPLNOME = :P_DSCOMPLNOME, SGUNIDADE = :P_SGUNIDADE, VRFATCORR = :P_VRFATCORR, VRFATOCONV = :P_VRFATOCONV, IDPRODESTO = :P_IDPRODESTO, CDPRODESTOINT = :P_CDPRODESTOINT, IDPRODATIVO = :P_IDPRODATIVO, IDACAO = :P_IDACAO, DTGRAVACAO = :P_DTGRAVACAO, HRGRAVACAO = :P_HRGRAVACAO, LOG_ERRO = NULL, DTIMPORTACAO = NULL, HRIMPORTACAO = NULL";
        $stQryparams = " WHERE CDPRODINT = :P_CDPRODINT";
        $stQryCompleta = '';
        foreach($arrayParams['DSNIVEL'] as $rowNum  => $rowVal) {
            $stQryNivel =  $stQryNivel.', DSNIVEL'.strval($rowNum+1).' = :P_DSNIVEL'.strval($rowNum+1);
        }
        $stQryCompleta = $stQryCampos.$stQryNivel.$stQryparams;
        
        return $stQryCompleta;
    }
    
    public function normalizaCadastroAtivo($CDTIPOCadastro, $cadastroAtiv){
        if($CDTIPOCadastro == 'fornecedor'){
            $cadastroAtiv == 'S'? $cadastroAtiv = 'A' : $cadastroAtiv = $cadastroAtiv;
            $cadastroAtiv == 'N'? $cadastroAtiv = 'I' : $cadastroAtiv = $cadastroAtiv;
        }
        if($CDTIPOCadastro == 'cliente'){
            $cadastroAtiv == 'A'? $cadastroAtiv = 'S' : $cadastroAtiv = $cadastroAtiv;
        }
        
        return $cadastroAtiv;
    }
    
    public function getProduto($codProduto){
        try{
            
            $params = array(
                'P_CDPRODINT' => $codProduto
            );
            return $this->entityManager->getConnection()->fetchAll(self::GET_PRODUTO, $params)[0]['RESUL'];
            }
             catch (\Exception $e) {
            return $e->getMessage();
        }
    }
    
    public function CadastraProduto($xml){;
        try{ 
            $params = $this->montaParamsSQL($xml);
            $params['P_DSCOMPLNOME'] = !isset($params['P_DSCOMPLNOME']) ? '' : $params['P_DSCOMPLNOME'];
            $params['P_CDPRODESTOINT'] = !isset($params['P_CDPRODESTO']) ? '' : $params['P_CDPRODESTO'];
            if($params['P_IDPRODESTO'] == 'CMP' && $params['P_CDPRODESTO'] == '')
                throw new \Exception("Deve ser informado o campo CDPRODESTO para produtos de estoque", 400);
            
            $qryProd = $this->montaQryProduto($xml);
            //INSERT_PRODUTO
            $this->entityManager->getConnection()->executeQuery($qryProd, $params);
            }
             catch (\Exception $e) {
            return $e->getMessage();
        }
    }
    
    public function UpdateProduto($xml, $excluir){;
        try{
            $params = $this->montaParamsSQL($xml);
            $params['P_IDACAO'] = $excluir;
            $qryUpdate = $this->montaQryUpdateProduto($xml);
            $this->entityManager->getConnection()->executeQuery($qryUpdate, $params);
            }
             catch (\Exception $e) {
            return $e->getMessage();
        }
    }
    
    public function getFornecedor($codForne){
        try{
            
            $params = array(
                'P_CGCFORNE' => $codForne
            );
            return $this->entityManager->getConnection()->fetchAll(self::GET_FORNECEDOR, $params)[0]['RESUL'];
            }
             catch (\Exception $e) {
            return $e->getMessage();
        }
    }
    
    public function CadastraFornecedor($xml){
        try{
            
            $params = $this->montaParamsSQL($xml);
            $this->entityManager->getConnection()->executeQuery(self::INSERT_FORNECEDOR, $params);
            }
             catch (\Exception $e) {
            return $e->getMessage();
        }
    }
    
    public function updateSoliCompra($nritemsolini, $nritemsolfin){
        try{
            $params = array(
                'P_NRITEMSOLIINI' => $nritemsolini,
                'P_NRITEMSOLIFIM' => $nritemsolfin
            );
            $this->entityManager->getConnection()->executeQuery(self::UPDATE_SOLICOMPRA, $params);
            }
             catch (\Exception $e) {
            return $e->getMessage();
        }
    }
    
    public function UpdateFornecedor($xml, $excluir){
        try{
            $params = $this->montaParamsSQL($xml);
            $params['P_IDACAO'] = $excluir;
            $this->entityManager->getConnection()->executeQuery(self::UPDATE_FORNECEDOR, $params);
            }
             catch (\Exception $e) {
            return $e->getMessage();
        }
    }
    
    public function getCliente($codClie){
        try{
            $params = array(
                'P_CGCCLIE' => $codClie
            );
            return $this->entityManager->getConnection()->fetchAll(self::GET_CLIENTE, $params)[0]['RESUL'];
            }
             catch (\Exception $e) {
            return $e->getMessage();
        }
    }
    
    public function getNFEntrada($nrnotafiscal, $cdproduto){
        try{
            $params = array(
                'P_NRNOTAFISCAL' => $nrnotafiscal,
                'P_CDPRODUTO' => $cdproduto
            );
            return $this->entityManager->getConnection()->fetchAll(self::GET_NFENTRADA, $params)[0]['RESUL'];
            }
             catch (\Exception $e) {
            return $e->getMessage();
        }
    }
    
    public function getDevolucaoCompra($nrnotafiscal, $cdproduto){
        try{
            $params = array(
                'P_NRNOTAFISCAL' => $nrnotafiscal,
                'P_CDPRODUTO' => $cdproduto
            );
            return $this->entityManager->getConnection()->fetchAll(self::GET_DEVOCOMPRA, $params)[0]['RESUL'];
            }
             catch (\Exception $e) {
            return $e->getMessage();
        }
    }
    
    public function getBaixaAutoForne($cdcentcust, $nrautoforne, $cditem, $cdproduto){
        try{
            $params = array(
                'P_CDCENTCUST' => $cdcentcust,
                'P_NRAUTOFORNE' => $nrautoforne,
                'P_CDITEM' => $cditem,
                'P_CDPRODUTO' => $cdproduto
            );
            return $this->entityManager->getConnection()->fetchAll(self::GET_BAIXAAUTF, $params)[0]['RESUL'];
            }
             catch (\Exception $e) {
            return $e->getMessage();
        }
    }
    
    public function getSoliCompra($nritemsolini, $nritemsolfin){
        try{
            $params = array(
                'P_NRITEMSOLIINI' => $nritemsolini,
                'P_NRITEMSOLIFIM' => $nritemsolfin
            );
            return $this->entityManager->getConnection()->fetchAll(self::GET_SOLICOMPRA, $params);
            }
        catch (\Exception $e) {
            return $e->getMessage();
        }
    }
    
    public function getMaxSoli(){
        try{
            $params = array();
            return $this->entityManager->getConnection()->fetchAll(self::GET_MAXSOLI, $params)[0]['MAXSOLI'];
            }
        catch (\Exception $e) {
            return $e->getMessage();
        }
    }
    
    public function getMinSoli(){
        try{
            $params = array();
            return $this->entityManager->getConnection()->fetchAll(self::GET_MINSOLI, $params)[0]['MINSOLI'];
            }
        catch (\Exception $e) {
            return $e->getMessage();
        }
    }
    
    public function CadastraCliente($xml){
        try{
            
            $params = $this->montaParamsSQL($xml);
            $this->entityManager->getConnection()->executeQuery(self::INSERT_CLIENTE, $params);
            }
             catch (\Exception $e) {
            return $e->getMessage();
        }
    }
    
    public function UpdateCliente($xml, $excluir){
        try{
            $params = $this->montaParamsSQL($xml);
            $params['P_IDACAO'] = $excluir;
            $this->entityManager->getConnection()->executeQuery(self::UPDATE_CLIENTE, $params);
            }
             catch (\Exception $e) {
            return $e->getMessage();
        }
    }
    
    public function ImportaNFEntrada($xml){
        $produtos = $xml['PRODUTO'];
        if(!$produtos[0]){
            $row['CDCENTCUST'] = $xml['CDCENTCUST'];
            $row['CDFORNECED'] = $xml['CDFORNECED'];
            $row['NRNOTAFISCAL'] = $xml['NRNOTAFISCAL'];
            $row['DTENTRADA'] = $xml['DTENTRADA'];
            $row['DTEMISSAO'] = $xml['DTEMISSAO'];
            $row['CDSERIE'] = $xml['CDSERIE'];
            $row['IDACAO'] = $xml['IDACAO'];
            $row['NRAUTOFORNE'] = $produtos['NRAUTOFORNE'];
            $row['CDPRODUTO'] = $produtos['CDPRODUTO'];
            $row['VRQUANTIDADE'] = $produtos['VRQUANTIDADE'];
            $row['VRQUANTAT'] = $produtos['VRQUANTAT'];
            $row['VRUNITARIO'] = $produtos['VRUNITARIO'];
            
            $NFEcadastrada = $this->getNFEntrada($row['NRNOTAFISCAL'], $row['CDPRODUTO']);
			switch($NFEcadastrada){
				case 0: 
					$mensagem = $this->InsertNFEntrada($row);
					break;
				case 1:
				    $excluir = $xml['IDACAO'] == '3' ? '3' : '2'; // 3 - excluir | 2 - updatar
					$mensagem = $this->UpdateImportaNFEntrada($row,$excluir);
					break;
				default:
					$mensagem = $NFEcadastrada;
					break;
            }
            
        }
        else{
            foreach($produtos as $produto){
                $row['CDCENTCUST'] = $xml['CDCENTCUST'];
                $row['CDFORNECED'] = $xml['CDFORNECED'];
                $row['NRNOTAFISCAL'] = $xml['NRNOTAFISCAL'];
                $row['DTENTRADA'] = $xml['DTENTRADA'];
                $row['DTEMISSAO'] = $xml['DTEMISSAO'];
                $row['IDACAO'] = $xml['IDACAO'];
                $row['CDSERIE'] = $xml['CDSERIE'];
                $row['NRAUTOFORNE'] = $produto['NRAUTOFORNE'];
                $row['CDPRODUTO'] = $produto['CDPRODUTO'];
                $row['VRQUANTIDADE'] = $produto['VRQUANTIDADE'];
                $row['VRQUANTAT'] = $produto['VRQUANTAT'];
                $row['VRUNITARIO'] = $produto['VRUNITARIO'];
                
                $NFEcadastrada = $this->getNFEntrada($row['NRNOTAFISCAL'], $row['CDPRODUTO']);
    			switch($NFEcadastrada){
    				case 0: 
    					$mensagem = $this->InsertNFEntrada($row);
    					break;
    				case 1:
    				    $excluir = $xml['IDACAO'] == '3' ? '3' : '2'; // 3 - excluir | 2 - updatar
    					$mensagem = $this->UpdateImportaNFEntrada($row, $excluir);
    					break;
    				default:
    					$mensagem = $NFEcadastrada;
    					break;
                }
            }
        }
            
        
            return $mensagem;
    }
    
    public function InsertNFEntrada($xml, $excluir){
        try{
                $params = $this->montaParamsSQL($xml);
                $excluir? $params['P_IDACAO'] = $excluir : null;
                //$params['P_CDCENTCUST'] = '9999'; //-> remover do webservice e pegar/preencher pela procedure.
                $this->entityManager->getConnection()->executeQuery(self::INSERT_IMPORTANFENTRADA, $params);
            }
             catch (\Exception $e) {
            return $e->getMessage();
        }
    }
    
    public function InsertDevolucaoCompra($xml, $excluir){
        try{
                $params = $this->montaParamsSQL($xml);
                $excluir? $params['P_IDACAO'] = $excluir : null;
                //$params['P_CDCENTCUST'] = '9999'; //-> remover do webservice e pegar/preencher pela procedure.
                $this->entityManager->getConnection()->executeQuery(self::INSERT_DEVOCOMPRA, $params);
            }
             catch (\Exception $e) {
            return $e->getMessage();
        }
    }
    
    public function GetAtualizaPedidoVenda($nrpedvenda){
        try{
            $params = array(
                'P_NRPEDVENDA' => $nrpedvenda
            );
            return $this->entityManager->getConnection()->fetchAll(self::GET_ATUPEDVENDA, $params)[0]['RESUL'];
            }
             catch (\Exception $e) {
            return $e->getMessage();
        }
    }
    
    public function AtualizaPedidoVenda($xml){;
        try{
            $params = $this->montaParamsSQL($xml);
            $this->entityManager->getConnection()->executeQuery(self::INSERT_ATUPEDVENDA, $params);
            }
             catch (\Exception $e) {
            return $e->getMessage();
        }
    }
    
    public function BaixaAutoForne($xml){
        try{
            
            $params = $this->montaParamsSQL($xml);
            $this->entityManager->getConnection()->executeQuery(self::INSERT_BAIXAUTF, $params);
            }
             catch (\Exception $e) {
            return $e->getMessage();
        }
    }
    
    public function UpdateAtualizaPedidoVenda($xml, $excluir){
        try{
            $params = $this->montaParamsSQL($xml);
            $params['P_IDACAO'] = $excluir;
            $this->entityManager->getConnection()->executeQuery(self::UPDATE_ATUPEDVENDA, $params);
            }
             catch (\Exception $e) {
            return $e->getMessage();
        }
    }
    
    public function UpdateImportaNFEntrada($xml, $excluir){
        try{
            $params = $this->montaParamsSQL($xml);
            $excluir? $params['P_IDACAO'] = $excluir : null;
            $this->entityManager->getConnection()->executeQuery(self::UPDATE_IMPORTANFE, $params);
            }
             catch (\Exception $e) {
            return $e->getMessage();
        }
    }
    
    public function UpdateDevolucaoCompra($xml, $excluir){
        try{
            $params = $this->montaParamsSQL($xml);
            $excluir? $params['P_IDACAO'] = $excluir : null;
            $this->entityManager->getConnection()->executeQuery(self::UPDATE_DEVOCOMPRA, $params);
            }
             catch (\Exception $e) {
            return $e->getMessage();
        }
    }
    
    public function updateBaixaAutoForne($xml, $excluir){
        try{
            $params = $this->montaParamsSQL($xml);
            $params['P_IDACAO'] = $excluir;
            $this->entityManager->getConnection()->executeQuery(self::UPDATE_BAIXAUTF, $params);
            }
             catch (\Exception $e) {
            return $e->getMessage();
        }
    }
    
    public function DevolucaoDeCompra($xml){
        $produtos = $xml['PRODUTO'];
        if(!$produtos[0]){
            $row['CDCENTCUST'] = $xml['CDCENTCUST'];
            $row['NRAUTOFORNE'] = $xml['NRAUTOFORNE'];
            $row['CDFORNECED'] = $xml['CDFORNECED'];
            $row['NRNOTAFISCAL'] = $xml['NRNOTAFISCAL'];
            $row['DTSAIDA'] = $xml['DTSAIDA'];
            $row['DTEMISSAO'] = $xml['DTEMISSAO'];
            $row['CDSERIE'] = $xml['CDSERIE'];
            $row['IDACAO'] = $xml['IDACAO'];
            $row['CDPRODUTO'] = $produtos['CDPRODUTO'];
            $row['VRQUANTIDADE'] = $produtos['VRQUANTIDADE'];
            $row['VRQUANTAT'] = $produtos['VRQUANTAT'];
            $row['VRUNITARIO'] = $produtos['VRUNITARIO'];
            
            $DevolucaoCadastrada = $this->getDevolucaoCompra($row['NRNOTAFISCAL'], $row['CDPRODUTO']);
            
			switch($DevolucaoCadastrada){
				case 0: 
					$mensagem = $this->InsertDevolucaoCompra($row);
					break;
				case 1:
				    $excluir = $xml['IDACAO'] == '3' ? '3' : '2'; // 3 - excluir | 2 - updatar
					$mensagem = $this->UpdateDevolucaoCompra($row,$excluir);
					break;
				default:
					$mensagem = $DevolucaoCadastrada;
					break;
            }
            
        }
        else{
            foreach($produtos as $produto){
                $row['CDCENTCUST'] = $xml['CDCENTCUST'];
                $row['NRAUTOFORNE'] = $xml['NRAUTOFORNE'];
                $row['CDFORNECED'] = $xml['CDFORNECED'];
                $row['NRNOTAFISCAL'] = $xml['NRNOTAFISCAL'];
                $row['DTSAIDA'] = $xml['DTSAIDA'];
                $row['DTEMISSAO'] = $xml['DTEMISSAO'];
                $row['IDACAO'] = $xml['IDACAO'];
                $row['CDSERIE'] = $xml['CDSERIE'];
                $row['CDPRODUTO'] = $produto['CDPRODUTO'];
                $row['VRQUANTIDADE'] = $produto['VRQUANTIDADE'];
                $row['VRQUANTAT'] = $produto['VRQUANTAT'];
                $row['VRUNITARIO'] = $produto['VRUNITARIO'];
                
                $DevolucaoCadastrada = $this->getDevolucaoCompra($row['NRNOTAFISCAL'], $row['CDPRODUTO']);
    			switch($DevolucaoCadastrada){
    				case 0: 
    					$mensagem = $this->InsertDevolucaoCompra($row);
    					break;
    				case 1:
    				    $excluir = $xml['IDACAO'] == '3' ? '3' : '2'; // 3 - excluir | 2 - updatar
    					$mensagem = $this->UpdateDevolucaoCompra($row, $excluir);
    					break;
    				default:
    					$mensagem = $DevolucaoCadastrada;
    					break;
                }
            }
        }
            
            return $mensagem;
    }

    public function CallProcedureImportaProduto(){
        try {
            $procedure = new StoredProcedure($this->entityManager->getConnection(), self::PROCEDURE_IMPORTA_PRODUTO);
            $procedure->addParam(new Param('P_MENSAGEMERRO', Param::PARAM_OUTPUT, '', Param::PARAM_TYPE_STR, 5000));
            //$procedure->addParam(new Param('P_CDPRODUTO', Param::PARAM_INPUT, $cdproduto, Param::PARAM_TYPE_STR));
            return $procedure->execute()['P_MENSAGEMERRO'];
        } catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function CallProcedureImportaFornecedor(){
        try {
            $procedure = new StoredProcedure($this->entityManager->getConnection(), self::PROCEDURE_IMPORTA_FORNECEDOR);
            $procedure->addParam(new Param('P_MENSAGEMERRO', Param::PARAM_OUTPUT, '', Param::PARAM_TYPE_STR, 5000));
            //$procedure->addParam(new Param('P_CDPRODUTO', Param::PARAM_INPUT, $cdproduto, Param::PARAM_TYPE_STR));
            return $procedure->execute()['P_MENSAGEMERRO'];
        } catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function CallProcedureImportaCliente(){
        try {
            $procedure = new StoredProcedure($this->entityManager->getConnection(), self::PROCEDURE_IMPORTA_CLIENTE);
            $procedure->addParam(new Param('P_MENSAGEMERRO', Param::PARAM_OUTPUT, '', Param::PARAM_TYPE_STR, 5000));
            //$procedure->addParam(new Param('P_CDPRODUTO', Param::PARAM_INPUT, $cdproduto, Param::PARAM_TYPE_STR));
            return $procedure->execute()['P_MENSAGEMERRO'];
        } catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function CallProcedureImportaNFEntrada(){
        try {
            $procedure = new StoredProcedure($this->entityManager->getConnection(), self::PROCEDURE_IMPORTA_NFENTRADA);
            $procedure->addParam(new Param('P_MENSAGEMERRO', Param::PARAM_OUTPUT, '', Param::PARAM_TYPE_STR, 5000));
            //$procedure->addParam(new Param('P_CDPRODUTO', Param::PARAM_INPUT, $cdproduto, Param::PARAM_TYPE_STR));
            return $procedure->execute()['P_MENSAGEMERRO'];
        } catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function CallProcedureImportaDevoCompra(){
        try {
            $procedure = new StoredProcedure($this->entityManager->getConnection(), self::PROCEDURE_IMPORTA_DEVOCOMPRA);
            $procedure->addParam(new Param('P_MENSAGEMERRO', Param::PARAM_OUTPUT, '', Param::PARAM_TYPE_STR, 5000));
            //$procedure->addParam(new Param('P_CDPRODUTO', Param::PARAM_INPUT, $cdproduto, Param::PARAM_TYPE_STR));
            return $procedure->execute()['P_MENSAGEMERRO'];
        } catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function CallProcedureAtualizaPedidoVenda(){
        try {
            $procedure = new StoredProcedure($this->entityManager->getConnection(), self::PROCEDURE_ATUALIZA_PEDIDOVENDA);
            $procedure->addParam(new Param('P_MENSAGEMERRO', Param::PARAM_OUTPUT, '', Param::PARAM_TYPE_STR, 5000));
            //$procedure->addParam(new Param('P_CDPRODUTO', Param::PARAM_INPUT, $cdproduto, Param::PARAM_TYPE_STR));
            return $procedure->execute()['P_MENSAGEMERRO'];
        } catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function CallProcedureBaixaAutoForne(){
        try {
            $procedure = new StoredProcedure($this->entityManager->getConnection(), self::PROCEDURE_BAIXA_AUTOFORNE);
            $procedure->addParam(new Param('P_MENSAGEMERRO', Param::PARAM_OUTPUT, '', Param::PARAM_TYPE_STR, 5000));
            //$procedure->addParam(new Param('P_CDPRODUTO', Param::PARAM_INPUT, $cdproduto, Param::PARAM_TYPE_STR));
            return $procedure->execute()['P_MENSAGEMERRO'];
        } catch (\Exception $e) {
            throw $e;
        }
    }

    // ********************INICIO METODOS CLIENT**************
    
    
    const GET_AFSEXPORTAR = 'SELECT DISTINCT CNPJEMPRESA, CDCENTCUST, NRAUTOFORNE, CDFORNECED, DTAUTOFORN, VRTOTALAF, CDCONDFORN, CDLOJA, IDACAO FROM USR_CISAUTO_FORNE WHERE DTIMPORTACAO IS NULL';
    const GET_PRODUTOAF = 'SELECT CDCENTCUST, NRAUTOFORNE, CDFORNECED, CDARMAZEM, DTAUTOFORN, VRTOTALAF, CDCONDFORN, CDLOJA, CDITEM, SGUNIDADE, CDPRODUTO, VRQUANTIDADE, VRUNITARIO, VRTOTAL, VRPERDESAF, VRDESCITMAF, TXOBSITMAF, IDACAO FROM USR_CISAUTO_FORNE WHERE DTIMPORTACAO IS NULL AND CDCENTCUST = :P_CDCENTCUST AND NRAUTOFORNE = :P_NRAUTOFORNE';
    const GET_NFSEXPORTAR = 'SELECT DISTINCT IDIMPORTADO, NRPEDVENDA, CDCENTCUST, CDCONDPAG, TES, CDCLIENTE, DTSAIDA, IDACAO FROM USR_CISPEDIDO_VENDA WHERE DTIMPORTACAO IS NULL';
    const GET_PRODUTONFS = 'SELECT CODARMAZEM, CDPRODUTO, SGUNIDADE, VRQUANTIDADE, VRUNITARIO, VRTOTAL, IDACAO, NRSEQITPROD FROM USR_CISPEDIDO_VENDA WHERE DTIMPORTACAO IS NULL AND CDFILIAL = :P_CDFILIAL AND NRLANCTONF = :P_NRLANCTONF';
    const UPDATE_AFEXPORTADAS = 'UPDATE USR_CISAUTO_FORNE SET DTIMPORTACAO = :P_DTIMPORTACAO, HRIMPORTACAO = :P_HRIMPORTACAO, LOG_ERRO = :P_LOG_ERRO WHERE CDCENTCUST = :P_CDCENTCUST AND NRAUTOFORNE = :P_NRAUTOFORNE';
    const UPDATE_ERROAFEXPORTADAS = 'UPDATE USR_CISAUTO_FORNE SET LOG_ERRO = :P_LOG_ERRO, DTIMPORTACAO = :P_DTIMPORTACAO WHERE CDCENTCUST = :P_CDCENTCUST AND NRAUTOFORNE = :P_NRAUTOFORNE';
    
    public function atualizaErroAfExportada($cdcentcust, $nrautoforne, $logerro, $data = null){
        try {
            $params['P_CDCENTCUST'] = $cdcentcust;
            $params['P_NRAUTOFORNE']  = $nrautoforne;
            $params['P_LOG_ERRO']  = $logerro;
            $params['P_DTIMPORTACAO'] = $data;
            
            $this->entityManager->getConnection()->executeQuery(self::UPDATE_ERROAFEXPORTADAS, $params);
        } catch (\Exception $e) {
            throw $e;
        }
    }   
    
    public function atualizaAfExportada($cdcentcust, $nrautoforne, $log){
        try {
            $params['P_DTIMPORTACAO'] = date('d/m/y');
            $params['P_HRIMPORTACAO'] = date('H:i');
            $params['P_CDCENTCUST'] = $cdcentcust;
            $params['P_NRAUTOFORNE']  = $nrautoforne;
            $params['P_LOG_ERRO']  = $log;
            
            $this->entityManager->getConnection()->executeQuery(self::UPDATE_AFEXPORTADAS, $params);
        } catch (\Exception $e) {
            throw $e;
        }
    }   
    
    public function retornaAfs(){
		try{
            return $this->entityManager->getConnection()->fetchAll(self::GET_AFSEXPORTAR);
            }
             catch (\Exception $e) {
            return $e->getMessage();
        } 
	}
	
	public function retornaProdutoAf($cdcentcust, $nrautoforne){
		try{
            $params = array(
                'P_CDCENTCUST' => $cdcentcust,
                'P_NRAUTOFORNE' => $nrautoforne
            );
            return $this->entityManager->getConnection()->fetchAll(self::GET_PRODUTOAF, $params);
            }
             catch (\Exception $e) {
            return $e->getMessage();
        } 
	}
	
	public function exportaAf(){
	    $cabecalhoAF = $this->retornaAfs();
        foreach($cabecalhoAF as $af){
            $dataAF = substr($af['DTAUTOFORN'], 0, 10);
            $dataAF = str_replace('/', '-', $dataAF);
            $dataAF = date('Y-m-d', strtotime($dataAF));
            $dataAF = str_replace('-', '', $dataAF);
            $produtosAF = $this->retornaProdutoAf($af['CDCENTCUST'], $af['NRAUTOFORNE']);
            $itemsXml = '';
            foreach($produtosAF as $produto){
                $produtoXml = '<TKPCITEM>
                                  <CDARMAZEM>'.$produto['CDARMAZEM'].'</CDARMAZEM>
                                  <CDCENTCUST>'.$produto['CDCENTCUST'].'</CDCENTCUST>
                                  <CDITEM>'.$produto['CDITEM'].'</CDITEM>
                                  <CDPRODUTO>'.$produto['CDPRODUTO'].'</CDPRODUTO>
                                  <SGUNIDADE>'.$produto['SGUNIDADE'].'</SGUNIDADE>
                                  <TXOBSITMAF>'.$produto['TXOBSITMAF'].'</TXOBSITMAF>
                                  <VRDESCITMAF>'.$produto['VRDESCITMAF'].'</VRDESCITMAF>
                                  <VRPERDESAF>'.$produto['VRPERDESAF'].'</VRPERDESAF>
                                  <VRQUANTIDADE>'.$produto['VRQUANTIDADE'].'</VRQUANTIDADE>
                                  <VRTOTAL>'.$produto['VRTOTAL'].'</VRTOTAL>
                                  <VRUNITARIO>'.$produto['VRUNITARIO'].'</VRUNITARIO>
                               </TKPCITEM>';
                $itemsXml = $itemsXml.$produtoXml;
            }
            $xml = '<TKAUTFOR01>
                         <_CNPJ>'.$af['CNPJEMPRESA'].'</_CNPJ>
                         <_IDACAO>'.$af['IDACAO'].'</_IDACAO>
                         <_PCDADOS>
                            <_PCITENS>'
                                .$itemsXml.
                            '</_PCITENS>
                            <CDCONDFORN>'.$af['CDCONDFORN'].'</CDCONDFORN>
                            <CDFORNECED>'.$af['CDFORNECED'].'</CDFORNECED>
                            <CDLOJA>'.$af['CDLOJA'].'</CDLOJA>
                            <DTAUTOFORN>'.$dataAF.'</DTAUTOFORN>
                            <NRAUTOFORNE>'.$af['NRAUTOFORNE'].'</NRAUTOFORNE>
                         </_PCDADOS>
                       </TKAUTFOR01>';
                       
            $xmlSimple = simplexml_load_string($xml);
            $xmlSimple = $this->xml2array($xmlSimple);
            //$xmlVar = new \SoapVar($xml, XSD_ANYXML, "http://www.w3.org/2001/XMLSchema", "ns1", "ns1");
            try {
                //$client = new \SoapClient( "http://192.168.254.253:8097/ws/TKAUTOFOR.apw?WSDL", array('trace' => 1, 'cache_wsdl' => WSDL_CACHE_NONE, 'soap_version' => SOAP_1_1) );
                
                $response = $client->__soapCall('TKAUTFOR01', array($xmlSimple));
                $resultado = $response->TKAUTFOR01RESULT;
                if($resultado->_STATUSOP == 'ok'){
                    $log = $resultado->LOG_ERRO;
                    $log = substr($log, 0, 4000);
                    $this->atualizaAfExportada($af['CDCENTCUST'], $af['NRAUTOFORNE'], $log);
                }else{
                    $log = $resultado->LOG_ERRO;
                    $log = substr($log, 0, 4000);
                    $this->atualizaAfExportada($af['CDCENTCUST'], $af['NRAUTOFORNE'], $log);
                    $xmlArrLog = $xmlSimple;
                    //$this->gravaLogWebservice($xml, 'ExportaAF', $xmlArrLog['_PCDADOS'], $log);
                }
                
                //vardump($client->__getLastResponseHeaders());
                //vardump($response);
                //vardump($client->__getLastRequest());
                //vardump($client->__getLastResponse());
                //echo "REQUEST:\n" . htmlentities($client->__getLastRequest()) . "\n";
                //vardump(htmlentities($client->__getLastRequest()));
            } catch (\Exception $e) {
                //vardump($e);
                $logerro = $e->getMessage();
                $logerro = substr($logerro, 0, 4000);
                $xmlArrLog = $xmlSimple;
                if(strpos($logerro, "Couldn't load from")){
                    $this->atualizaErroAfExportada($af['CDCENTCUST'], $af['NRAUTOFORNE'], $logerro, null);
                    sleep(300);
                    //$this->exportaAf();
                }else{
                    $data = date('d/m/y');
                    $this->atualizaErroAfExportada($af['CDCENTCUST'], $af['NRAUTOFORNE'], $logerro, $data);
                    //$this->exportaAf();
                }
                //$this->gravaLogWebservice($xml, 'ExportaAF', $xmlArrLog['_PCDADOS'], $logerro);
                //vardump($client->__getLastResponse());
                //echo "REQUEST:\n" . htmlentities($client->__getLastRequest()) . "\n";
                //vardump(htmlentities($client->__getLastRequest()));
                //vardump(PHP_EOL);
                //vardump($client->__getLastRequest());
                //vardump($client->__getLastResponseHeaders());
            }
        }
        vardump('Procedimento Finalizado');
	}
	
	public function retornaNfsSaida(){
		try{
            return $this->entityManager->getConnection()->fetchAll(self::GET_NFSEXPORTAR);
            }
             catch (\Exception $e) {
            return $e->getMessage();
        } 
	}
	
	public function retornaProdutoNfSaida($cdcentcust, $nrautoforne){
		try{
            $params = array(
                'P_CDCENTCUST' => $cdcentcust,
                'P_NRAUTOFORNE' => $nrautoforne
            );
            return $this->entityManager->getConnection()->fetchAll(self::GET_PRODUTONFS, $params);
            }
             catch (\Exception $e) {
            return $e->getMessage();
        } 
	}
	
	public function exportaNfs(){
	    $cabecalhoAF = $this->retornaNfsSaida();
        
        foreach($cabecalhoAF as $af){
            $produtosAF = $this->retornaProdutoAf($af['CDCENTCUST'], $af['NRAUTOFORNE']);
            $itemsXml = '';
            foreach($produtosAF as $produto){
                $produtoXml = '<TKPCITEM>
                                  <CDARMAZEM>'.$produto['CDARMAZEM'].'</CDARMAZEM>
                                  <CDCENTCUST>'.$produto['CDCENTCUST'].'</CDCENTCUST>
                                  <CDITEM>'.$produto['CDITEM'].'</CDITEM>
                                  <CDPRODUTO>'.$produto['CDPRODUTO'].'</CDPRODUTO>
                                  <SGUNIDADE>'.$produto['SGUNIDADE'].'</SGUNIDADE>
                                  <TXOBSITMAF>'.$produto['TXOBSITMAF'].'</TXOBSITMAF>
                                  <VRDESCITMAF>'.$produto['VRDESCITMAF'].'</VRDESCITMAF>
                                  <VRPERDESAF>'.$produto['VRPERDESAF'].'</VRPERDESAF>
                                  <VRQUANTIDADE>'.$produto['VRQUANTIDADE'].'</VRQUANTIDADE>
                                  <VRTOTAL>'.$produto['VRTOTAL'].'</VRTOTAL>
                                  <VRUNITARIO>'.$produto['VRUNITARIO'].'</VRUNITARIO>
                               </TKPCITEM>';
                $itemsXml = $itemsXml.$produtoXml;
            }
            $xml = '<TKAUTFOR01>
                         <_CNPJ>'.$af['CNPJEMPRESA'].'</_CNPJ>
                         <_IDACAO>'.$af['IDACAO'].'</_IDACAO>
                         <_PCDADOS>
                            <_PCITENS>'
                                .$itemsXml.
                            '</_PCITENS>
                            <CDCONDFORN>'.$af['CDCONDFORN'].'</CDCONDFORN>
                            <CDFORNECED>'.$af['CDFORNECED'].'</CDFORNECED>
                            <CDLOJA>'.$af['CDLOJA'].'</CDLOJA>
                            <DTAUTOFORN>'.substr($af['DTAUTOFORN'], 0, 10).'</DTAUTOFORN>
                            <NRAUTOFORNE>'.$af['NRAUTOFORNE'].'</NRAUTOFORNE>
                         </_PCDADOS>
                       </TKAUTFOR01>';
                       
            $xmlSimple = simplexml_load_string($xml);
            $xmlSimple = $this->xml2array($xmlSimple);
            //$xmlVar = new \SoapVar($xml, XSD_ANYXML, "http://www.w3.org/2001/XMLSchema", "ns1", "ns1");
            try {
                $client = new \SoapClient( "http://192.168.254.253:8097/ws/TKAUTOFOR.apw?WSDL", array('trace' => 1, 'cache_wsdl' => WSDL_CACHE_NONE, 'soap_version' => SOAP_1_1) );
                
                $response = $client->__soapCall('TKAUTFOR01', array($xmlSimple));
                $resultado = $response->TKAUTFOR01RESULT;
                if($resultado->_STATUSOP == 'ok'){
                    $log = $resultado->LOG_ERRO;
                    $this->atualizaAfExportada($af['CDCENTCUST'], $af['NRAUTOFORNE'], $log);
                }else{
                    $log = $resultado->LOG_ERRO;
                    $this->atualizaErroAfExportada($af['CDCENTCUST'], $af['NRAUTOFORNE'], $log);
                    $xmlArrLog = $xmlSimple;
                    $this->gravaLogWebservice($xml, 'ExportaAF', $xmlArrLog['_PCDADOS'], $resultado->LOG_ERRO);
                }
                
                //vardump($client->__getLastResponseHeaders());
                //vardump($response);
                //vardump($client->__getLastRequest());
                //vardump($client->__getLastResponse());
                //echo "REQUEST:\n" . htmlentities($client->__getLastRequest()) . "\n";
                //vardump(htmlentities($client->__getLastRequest()));
            } catch (\Exception $e) {
                $logerro = $e->getMessage();
                echo($logerro);
                $this->atualizaErroAfExportada($af['CDCENTCUST'], $af['NRAUTOFORNE'], $logerro);
                $xmlArrLog = $xmlSimple;
                $this->gravaLogWebservice($xml, 'ExportaAF', $xmlArrLog['_PCDADOS'], $resultado->LOG_ERRO);
                echo($client->__getLastResponse());
                //echo "REQUEST:\n" . htmlentities($client->__getLastRequest()) . "\n";
                //vardump(htmlentities($client->__getLastRequest()));
                //vardump(PHP_EOL);
                //vardump($client->__getLastRequest());
                //vardump($client->__getLastResponseHeaders());
            }
        }
        echo('Procedimento Finalizado');
	}
	
	public function xml2array( $xmlObject, $out = array () ){
        foreach ( (array) $xmlObject as $index => $node )
            $out[$index] = ( is_object ( $node ) ) ? $this->xml2array ( $node ) : $node;
    
        return $out;
    }
    
    public function obj_to_array($data){

            if (is_array($data) || is_object($data)){
                $result = array();
                foreach ($data as $key => $value){
                    $result[$key] = $this->obj_to_array($value);
                }
                return $result;
            }
            return $data;
    }
    
    public function consultaProduto($cdproduto, $cdprodint, $cdarvprod){
        try {
            $sql = "SELECT P.CDPRODINTE, P.CDARVPROD, P.CDPRODUTO, PE.CDPRODINTE AS CDPRODESTOINT, P.CDPRODESTO, PE.CDARVPROD AS CDARVPRODESTO, P.NMPRODUTO, P.DSCOMPLNOME, P.SGUNIDADE, P.VRPEFATOCORR,
                    P.VRFATOCONV, U.IDPRODESTO, P.IDPRODATIVPR, U.DTINCLUSAO
                    FROM PRODUTO P, PRODUTO PE,
                    (SELECT CDARVPRODINT, IDPRODESTO, MAX(DTIMPORTACAO) AS DTINCLUSAO
                    FROM USR_PRODUTO
                    WHERE NOT DTIMPORTACAO IS NULL
                    GROUP BY CDARVPRODINT, IDPRODESTO) U
                    WHERE (P.CDPRODUTO LIKE '%'||:P_CDPRODUTO||'%'
                    OR :P_CDPRODUTO IS NULL)
                    AND (P.CDPRODINTE LIKE '%'||:P_CDPRODINT||'%'
                    OR :P_CDPRODINT IS NULL)
                    AND (P.CDARVPROD LIKE '%'||:P_CDARVPROD||'%'
                    OR :P_CDARVPROD IS NULL)
                    AND P.CDARVPROD = U.CDARVPRODINT (+)
                    AND P.CDPRODESTO = PE.CDPRODUTO (+)
                    ORDER BY CDARVPROD";
    
            $params = array(
                'P_CDPRODUTO'        => $cdproduto,
                'P_CDPRODINT'        => $cdprodint,
                'P_CDARVPROD'        => $cdarvprod
            );
            return $this->entityManager->getConnection()->fetchAll($sql, $params);
        }catch (\Exception $e) {
            throw $e;
        }
    }

    public function previsaoConsumo($cdexfilial, $dtiniprevcons, $dtfimprevcons, $cdservfili){
        try {
            $sql = "SELECT CDEXFILIAL,
                            PREVCONS.CDFILIAL,
                            FILIAL.NMFILIAL,
                            SERVICO.CDSERVFILI,
                            SERVICO.NMSERVICO,
                            PREVCONS.DTPREVCONS,
                            PRODUTO.CDPRODINTE,
                            PRODUTO.CDPRODUTO,
                            PRODUTO.CDARVPROD,
                            PRODUTO.NMPRODUTO,
                            PREVCONS.QTPREVCONS
                            FROM PREVCONS
                            INNER JOIN PRODUTO
                            ON PREVCONS.CDPRODUTO = PRODUTO.CDPRODUTO
                            
                            INNER JOIN FILIAL
                            ON PREVCONS.CDFILIAL = FILIAL.CDFILIAL
                            
                            INNER JOIN SERVICO
                            ON PREVCONS.CDFILIAL = SERVICO.CDFILIAL
                            AND PREVCONS.CDSERVFILI = SERVICO.CDSERVFILI
                            
                            INNER JOIN PARAMFILIAL
                            ON PARAMFILIAL.CDFILIAL = FILIAL.CDFILIAL
                            
                            WHERE PREVCONS.DTPREVCONS BETWEEN :P_DTINIPREVCONS AND :P_DTFIMPREVCONS
                            AND PREVCONS.CDSERVFILI = NVL(:P_CDSERVFILI, PREVCONS.CDSERVFILI)
                            AND PARAMFILIAL.CDFILIAL = NVL(:P_CDEXFILIAL,PARAMFILIAL.CDFILIAL)";
    
            $params = array(
                'P_CDEXFILIAL'      => $cdexfilial,
                'P_DTINIPREVCONS'   => $dtiniprevcons,
                'P_DTFIMPREVCONS'   => $dtfimprevcons,
                'P_CDSERVFILI'      => $cdservfili
            );
            
            return $this->entityManager->getConnection()->fetchAll($sql, $params);
        }catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function insertCabecalhoEntrada($dataSet){
        try {
            $sql = "INSERT INTO USR_ENTR_MERC(IDENTRSAID, CDCODOC, CDEXFILIAL, CDFILIAL, DSDESCRICAO, DTENTRADA, DTINCLUSAO, NRLANCTOUSR, NRINSJURFORN, CDSERIE)
                    VALUES (:P_IDENTRSAID, :P_CDCODOC, :P_CDEXFILIAL, :P_CDFILIAL, :P_DSDESCRICAO, :P_DTENTRADA, :P_DTINCLUSAO, :P_NRLANCTOUSR, :P_NRINSJURFORN, :P_CDSERIE)";
    
            $params = array(
                'P_IDENTRSAID'  => $dataSet['IDENTRSAID'],
                'P_CDCODOC'     => $dataSet['NRDOCUMENT'],
                'P_CDEXFILIAL'  => $dataSet['CDEXFILIAL'],
                'P_CDFILIAL'    => $dataSet['CDFILIAL'],
                'P_DSDESCRICAO' => $dataSet['DSDESCRICAO'],
                'P_DTENTRADA'   => $dataSet['DTENTRSAID'],
                'P_DTINCLUSAO'  => date('d/m/Y'),//$dataSet['DTINCLUSAO'],
                'P_NRLANCTOUSR' => $dataSet['NRLANCTOUSR'],
                'P_NRINSJURFORN'=> $dataSet['NRINSJUR'],
                'P_CDSERIE'     => $dataSet['CDSERIE']
            );
            
            $this->entityManager->getConnection()->executeQuery($sql, $params);
            
            return false;
            
        }catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function insertItensEntrada($dataSet){
        try {
            
            $sql = "INSERT INTO USR_ITEM_ENTR_MERC(CDPRODINTE, VRQUANTIDADE, VRUNITARIO, CDEXFILIAL, CDFILIAL, NRLANCTOUSR, SGUNIDMED,
                                                    CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE)
                    VALUES (:P_CDPRODINTE, :P_VRQUANTIDADE, :P_VRUNITARIO, :P_CDEXFILIAL, :P_CDFILIAL, :P_NRLANCTOUSR, :P_SGUNIDMED,
                            :P_CDALMOXARIFE, :P_CDLOCALESTOQ, :P_NRLOTEESTQ, :P_NRSUBLOTE)";
            
            $itens = isset($dataSet['ITENS'])? $dataSet['ITENS'] : $dataSet['PRODUTO'];
            
            foreach($itens as $item){
                
                $params = array(
                    'P_CDPRODINTE'      => $item['CDPRODINTE'],
                    'P_VRQUANTIDADE'    => $item['QTPRODUTO'],
                    'P_VRUNITARIO'      => $item['VRUNITARIO'],
                    'P_CDEXFILIAL'      => $dataSet['CDEXFILIAL'],
                    'P_CDFILIAL'        => $dataSet['CDFILIAL'],
                    'P_NRLANCTOUSR'     => $dataSet['NRLANCTOUSR'],
                    'P_SGUNIDMED'       => $item['SGUNIDMED']?? null,
                    'P_CDALMOXARIFE'    => $item['CDALMOXARIFE']?? null,
                    'P_CDLOCALESTOQ'    => $item['CDLOCALESTOQ']?? null,
                    'P_NRLOTEESTQ'      => $item['NRLOTEESTQ']?? null,
                    'P_NRSUBLOTE'       => $item['NRSUBLOTE']?? null
                );
                $this->entityManager->getConnection()->executeQuery($sql, $params);
            }
            
            return false;
            
        }catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function buscaEXFilial($cdexfilial){
        try {
            $sql = "SELECT CDFILIAL
                    FROM PARAMFILIAL
                    WHERE NVL(CDEXFILIAL, CDFILIAL) = :P_CDEXFILIAL";
    
            $params = array(
                'P_CDEXFILIAL'      => $cdexfilial
            );
            
            return $this->entityManager->getConnection()->fetchAll($sql, $params);
        }catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function geraNovoCodigo($nrorg, $cdcontador){
        try {
            /** @var Novocodigo $novocodigo */
            $novocodigo = $this->newCode->getCodeByTableName($cdcontador, $nrorg);
            return $novocodigo;
        } catch (\Exception $e) {
            throw $e;
            return null;
        }
    }
    
    public function importaEntrada($dataSet){
        try {
            try{
                $cdfilial = $this->buscaEXFilial($dataSet['CDEXFILIAL'])[0]['CDFILIAL'];
            }catch (\Exception $e) {
                throw new \Exception('Codigo CDEXFILIAL não existe');
            }

            $chave = 'NRLANCTOUSR'.$cdfilial;
            
            $nrlanctousr = $this->geraNovoCodigo(1, $chave);
            $dataSet['NRLANCTOUSR'] = $nrlanctousr;
            $dataSet['CDFILIAL'] = $cdfilial;
            
            $insertCabec = $this->insertCabecalhoEntrada($dataSet);
            
            $insertItens = $this->insertItensEntrada($dataSet);
            
            $retornoProc = $this->CallProcedureUSR_IMPORTA_MERCADORIA();
            
            return $retornoProc;
            
        }catch (\Exception $e) {
            throw $e;
        }
    }

    public function CallProcedureUSR_IMPORTA_MERCADORIA(){
        try{
            $procedure = new StoredProcedure($this->entityManager->getConnection(), 'USR_IMPORTA_MERCADORIA');
            $procedure->addParam(new Param('P_MENSAGEMERRO', Param::PARAM_OUTPUT, '', Param::PARAM_TYPE_STR, 3000));
            return $procedure->execute();
        }catch(\Exception $e){
            return $e->getMessage();
        }
    }
    
}